Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.core.resources
Interface IFolder

All Superinterfaces:
  IAdaptable, IContainer, IResource, ISchedulingRule

public interface IFolder
extends IContainer, IAdaptable

Folders may be leaf or non-leaf resources and may contain files and/or other folders. A folder resource is stored as a directory in the local file system.

Folders, like other resource types, may exist in the workspace but not be local; non-local folder resources serve as placeholders for folders whose properties have not yet been fetched from a repository.

This interface is not intended to be implemented by clients.

Folders implement the `IAdaptable` interface; extensions are managed by the platform's adapter manager.

See Also:
  `Platform.getAdapterManager()`

Field Summary

Fields inherited from interface org.eclipse.core.resources.IContainer
`INCLUDE_PHANTOMS, INCLUDE_TEAM_PRIVATE_MEMBERS`

Fields inherited from interface org.eclipse.core.resources.IResource
`ALLOW_MISSING_LOCAL, ALWAYS_DELETE_PROJECT_CONTENT, AVOID_NATURE_CONFIG, DEPTH_INFINITE, DEPTH_ONE, DEPTH_ZERO, FILE, FOLDER, FORCE, KEEP_HISTORY, NEVER_DELETE_PROJECT_CONTENT, NONE, NULL_STAMP, PROJECT, ROOT, SHALLOW`

Method Summary
`void` | `create(boolean force, boolean local, IProgressMonitor monitor)` Creates a new folder resource as a member of this handle's parent resource.
`void` | `create(int updateFlags, boolean local, IProgressMonitor monitor)` Creates a new folder resource as a member of this handle's parent resource.
`void` | `createLink(IPath localLocation, int updateFlags, IProgressMonitor monitor)` Creates a new folder resource as a member of this handle's parent resource.
`void` | `delete(boolean force, boolean keepHistory, IProgressMonitor monitor)` Deletes this resource from the workspace.
`IFile` | `getFile(String name)` Returns a handle to the file with the given name in this folder.
`IFolder` | `getFolder(String name)` Returns a handle to the folder with the given name in this folder.
`void` | `move(IPath destination, boolean force, boolean keepHistory, IProgressMonitor monitor)` Moves this resource so that it is located at the given path.

Methods inherited from interface org.eclipse.core.resources.IContainer
`exists, findDeletedMembersWithHistory, findMember, findMember, findMember, findMember, getDefaultCharset, getDefaultCharset, getFile, getFolder, members, members, members, setDefaultCharset, setDefaultCharset`

Methods inherited from interface org.eclipse.core.resources.IResource
`accept, accept, accept, accept, clearHistory, copy, copy, copy, copy, createMarker, delete, delete, deleteMarkers, equals, exists, findMarker, findMarkers, getFileExtension, getFullPath, getLocalTimeStamp, getLocation, getMarker, getModificationStamp, getName, getParent, getPersistentProperty, getProject, getProjectRelativePath, getRawLocation, getSessionProperty, getType, getWorkspace, isAccessible, isDerived, isLinked, isLocal, isPhantom, isReadOnly, isSynchronized, isTeamPrivateMember, move, move, move, move, refreshLocal, setDerived, setLocal, setLocalTimeStamp, setPersistentProperty, setReadOnly, setSessionProperty, setTeamPrivateMember, touch`

Methods inherited from interface org.eclipse.core.runtime.IAdaptable
`getAdapter`

Methods inherited from interface org.eclipse.core.runtime.jobs.ISchedulingRule
`contains, isConflicting`

Method Detail

### create

    public void create(boolean force,
                       boolean local,
                       IProgressMonitor monitor)
                throws CoreException

  Creates a new folder resource as a member of this handle's parent resource.

  This is a convenience method, fully equivalent to:

         create((force ? FORCE : IResource.NONE), local, monitor);

  This method changes resources; these changes will be reported in a subsequent resource change event, including an indication that the folder has been added to its parent.

  This method is long-running; progress and cancellation are provided by the given progress monitor.

  Parameters:
    `force` - a flag controlling how to deal with resources that are not in sync with the local file system
    `local` - a flag controlling whether or not the folder will be local after the creation
    `monitor` - a progress monitor, or `null` if progress reporting is not desired
  Throws:
    `CoreException` - if this method fails. Reasons include:
    - This resource already exists in the workspace.
    - The workspace contains a resource of a different type at the same path as this resource.
    - The parent of this resource does not exist.
    - The parent of this resource is a project that is not open.
    - The parent contains a resource of a different type at the same path as this resource.
    - The name of this resource is not valid (according to `IWorkspace.validateName`).
    - The corresponding location in the local file system is occupied by a file (as opposed to a directory).
    - The corresponding location in the local file system is occupied by a folder and `force` is `false`.
    - Resource changes are disallowed during certain types of resource change event notification. See `IResourceChangeEvent` for more details.
    `OperationCanceledException` - if the operation is canceled. Cancelation can occur even if no progress monitor is provided.
  See Also:
    `create(int,boolean,IProgressMonitor)`

### create

    public void create(int updateFlags,
                       boolean local,
                       IProgressMonitor monitor)
                throws CoreException

  Creates a new folder resource as a member of this handle's parent resource.

  The `FORCE` update flag controls how this method deals with cases where the workspace is not completely in sync with the local file system. If `FORCE` is not specified, the method will only attempt to create a directory in the local file system if there isn't one already. This option ensures there is no unintended data loss; it is the recommended setting. However, if `FORCE` is specified, this method will be deemed a success even if there already is a corresponding directory.

  Update flags other than `FORCE` are ignored.

  This method synchronizes this resource with the local file system.

  This method changes resources; these changes will be reported in a subsequent resource change event, including an indication that the folder has been added to its parent.

  This method is long-running; progress and cancellation are provided by the given progress monitor.

  Parameters:
    `updateFlags` - bit-wise or of update flag constants (only `FORCE` is relevant here)
    `local` - a flag controlling whether or not the folder will be local after the creation
    `monitor` - a progress monitor, or `null` if progress reporting is not desired
  Throws:
    `CoreException` - if this method fails. Reasons include:
    - This resource already exists in the workspace.
    - The workspace contains a resource of a different type at the same path as this resource.
    - The parent of this resource does not exist.
    - The parent of this resource is a project that is not open.
    - The parent contains a resource of a different type at the same path as this resource.
    - The name of this resource is not valid (according to `IWorkspace.validateName`).
    - The corresponding location in the local file system is occupied by a file (as opposed to a directory).
    - The corresponding location in the local file system is occupied by a folder and `FORCE` is not specified.
    - Resource changes are disallowed during certain types of resource change event notification. See `IResourceChangeEvent` for more details.
    `OperationCanceledException` - if the operation is canceled. Cancelation can occur even if no progress monitor is provided.
  Since:
    2.0
  See Also:
    `IResourceRuleFactory.createRule(IResource)`

### createLink

    public void createLink(IPath localLocation,
                           int updateFlags,
                           IProgressMonitor monitor)
                    throws CoreException

  Creates a new folder resource as a member of this handle's parent resource. The folder's contents will be located in the directory specified by the given file system path. The given path must be either an absolute file system path, or a relative path whose first segment is the name of a workspace path variable.

  The `ALLOW_MISSING_LOCAL` update flag controls how this method deals with cases where the local file system directory to be linked does not exist, or is relative to a workspace path variable that is not defined. If `ALLOW_MISSING_LOCAL` is specified, the operation will suceed even if the local directory is missing, or the path is relative to an undefined variable. If `ALLOW_MISSING_LOCAL` is not specified, the operation will fail in the case where the local file system directory does not exist or the path is relative to an undefined variable.

  Update flags other than `ALLOW_MISSING_LOCAL` are ignored.

  This method synchronizes this resource with the local file system at the given location.

  This method changes resources; these changes will be reported in a subsequent resource change event, including an indication that the folder has been added to its parent.

  This method is long-running; progress and cancellation are provided by the given progress monitor.

  Parameters:
    `localLocation` - a file system path where the folder should be linked
    `updateFlags` - bit-wise or of update flag constants (only ALLOW_MISSING_LOCAL is relevant here)
    `monitor` - a progress monitor, or `null` if progress reporting is not desired
  Throws:
    `CoreException` - if this method fails. Reasons include:
    - This resource already exists in the workspace.
    - The workspace contains a resource of a different type at the same path as this resource.
    - The parent of this resource does not exist.
    - The parent of this resource is not an open project
    - The name of this resource is not valid (according to `IWorkspace.validateName`).
    - The corresponding location in the local file system does not exist, or is relative to an undefined variable, and `ALLOW_MISSING_LOCAL` is not specified.
    - The corresponding location in the local file system is occupied by a file (as opposed to a directory).
    - Resource changes are disallowed during certain types of resource change event notification. See `IResourceChangeEvent` for more details.
    - The team provider for the project which contains this folder does not permit linked resources.
    - This folder's project contains a nature which does not permit linked resources.
    `OperationCanceledException` - if the operation is canceled. Cancelation can occur even if no progress monitor is provided.
  Since:
    2.1
  See Also:
    `IResource.isLinked()`, `IResource.ALLOW_MISSING_LOCAL`

### delete

    public void delete(boolean force,
                       boolean keepHistory,
                       IProgressMonitor monitor)
                throws CoreException

  Deletes this resource from the workspace.

  This is a convenience method, fully equivalent to:

         delete((keepHistory ? KEEP_HISTORY : IResource.NONE) | (force ? FORCE : IResource.NONE), monitor);

  This method changes resources; these changes will be reported in a subsequent resource change event, including an indication that this folder has been removed from its parent.

  This method is long-running; progress and cancellation are provided by the given progress monitor.

  Parameters:
    `force` - a flag controlling whether resources that are not in sync with the local file system will be tolerated
    `keepHistory` - a flag controlling whether files under this folder should be stored in the workspace's local history
    `monitor` - a progress monitor, or `null` if progress reporting is not desired
  Throws:
    `CoreException` - if this method fails. Reasons include:
    - This resource could not be deleted for some reason.
    - This resource is out of sync with the local file system and `force` is `false`.
    - Resource changes are disallowed during certain types of resource change event notification. See `IResourceChangeEvent` for more details.
    `OperationCanceledException` - if the operation is canceled. Cancelation can occur even if no progress monitor is provided.
  See Also:
    `IResourceRuleFactory.deleteRule(IResource)`, `IResource.delete(int,IProgressMonitor)`

### getFile

    public IFile getFile(String name)

  Returns a handle to the file with the given name in this folder.

  This is a resource handle operation; neither the resource nor the result need exist in the workspace. The validation check on the resource name/path is not done when the resource handle is constructed; rather, it is done automatically as the resource is created.

  Parameters:
    `name` - the string name of the member file
  Returns:
    the (handle of the) member file
  See Also:
    `getFolder(String)`

### getFolder

    public IFolder getFolder(String name)

  Returns a handle to the folder with the given name in this folder.

  This is a resource handle operation; neither the container nor the result need exist in the workspace. The validation check on the resource name/path is not done when the resource handle is constructed; rather, it is done automatically as the resource is created.

  Parameters:
    `name` - the string name of the member folder
  Returns:
    the (handle of the) member folder
  See Also:
    `getFile(String)`

### move

    public void move(IPath destination,
                     boolean force,
                     boolean keepHistory,
                     IProgressMonitor monitor)
              throws CoreException

  Moves this resource so that it is located at the given path.

  This is a convenience method, fully equivalent to:

         move(destination, (keepHistory ? KEEP_HISTORY : IResource.NONE) | (force ? FORCE : IResource.NONE), monitor);

  This method changes resources; these changes will be reported in a subsequent resource change event, including an indication that this folder has been removed from its parent and a new folder has been added to the parent of the destination.

  This method is long-running; progress and cancellation are provided by the given progress monitor.

  Parameters:
    `destination` - the destination path
    `force` - a flag controlling whether resources that are not in sync with the local file system will be tolerated
    `keepHistory` - a flag controlling whether files under this folder should be stored in the workspace's local history
    `monitor` - a progress monitor, or `null` if progress reporting is not desired
  Throws:
    `CoreException` - if this resource could not be moved. Reasons include:
    - This resource does not exist.
    - This resource or one of its descendents is not local.
    - The resource corresponding to the parent destination path does not exist.
    - The resource corresponding to the parent destination path is a closed project.
    - A resource at destination path does exist.
    - A resource of a different type exists at the destination path.
    - This resource or one of its descendents is out of sync with the local file system and `force` is `false`.
    - The workspace and the local file system are out of sync at the destination resource or one of its descendents.
    - Resource changes are disallowed during certain types of resource change event notification. See `IResourceChangeEvent` for more details.
    `OperationCanceledException` - if the operation is canceled. Cancelation can occur even if no progress monitor is provided.
  See Also:
    `IResourceRuleFactory.moveRule(IResource, IResource)`, `IResource.move(IPath,int,IProgressMonitor)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Guidelines for using Eclipse APIs.

Copyright (c) IBM Corp. and others 2000, 2004. All rights reserved.